//+------------------------------------------------------------------+
//|                            Click-and-drag all stop losses EA.mq4 |
//|                                                    Steve Hopwood |
//|                                     www.hopwood3.freeserve.co.uk |
//+------------------------------------------------------------------+
#property copyright "Steve Hopwood"
#property link      "www.hopwood3.freeserve.co.uk"
#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"

/*
void SetStop()
void SetTp()
void DetectTrade()

*/

      
extern int        InstantSl=100;
extern color      Color.StopLoss = Red;

double            SL,TP;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//----
      
      //Accommodate different quote sizes
      double multiplier;
      if(Digits == 2 || Digits == 4) multiplier = 1;
      if(Digits == 3 || Digits == 5) multiplier = 10;
      if(Digits == 6) multiplier = 100;   
      InstantSl*= multiplier;

      
      start();
      
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");

//----
   return(0);
}

//+------------------------------------------------------------------+



void SetStop()
{
   //Sets up a stop when none exists
   
   if (OrderType() == OP_BUY)
   {
      SL = NormalizeDouble(Ask - (InstantSl * Point),Digits);
   }//if (OrderType() == OP_BUY)
   
   if (OrderType() == OP_SELL)
   {
      SL = NormalizeDouble(Bid + (InstantSl * Point),Digits);
   }//if (OrderType() == OP_BUY)
   
   
}//End void SetStop()

void DrawLine(string name, double price, color col)
{
   
   ObjectCreate(name, OBJ_HLINE, 0, TimeCurrent(), price);
   ObjectSet(name, OBJPROP_COLOR, col);
   ObjectSet(name, OBJPROP_STYLE, STYLE_DASH);
   

}//void DrawLine(string name, double price, color col)

void DeleteOrphanTpSlLines()
{

   if (ObjectsTotal() == 0) return;
   
   for (int cc = ObjectsTotal() - 1; cc >= 0; cc--)
   {
      string name = ObjectName(cc);
      
      if (ObjectType(name) == OBJ_HLINE)
      {
         int tn = StrToDouble(StringSubstr(name, 2));
         if (tn > 0) 
         {
            if (!OrderSelect(tn, SELECT_BY_TICKET, MODE_TRADES) || OrderCloseTime() > 0)
            {
               ObjectDelete(name);
            }//if (!OrderSelect(tn, SELECT_BY_TICKET, MODE_TRADES) || OrderCloseTime() > 0)
         }//if (tn > 0) 
      }//if (ObjectType(name) == OBJ_HLINE)
   }//for (int cc = ObjectsTotal() - 1; cc >= 0; cc--)
   
   
}//End void DeleteOrphanTpSlLines()


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   
   //Delete orphaned tp/sl lines
   static int M15Bars;
   if (M15Bars != iBars(NULL, PERIOD_M15) )
   {
      M15Bars = iBars(NULL, PERIOD_M15);
      DeleteOrphanTpSlLines();
   }//if (M15Bars != iBars(NULL, PERIOD_M15)

   
   if (OrdersTotal() == 0) return;
   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderSymbol() != Symbol() ) continue;
      
      string HlineName = DoubleToStr(OrderTicket(), 0);
      
      //Set missing tp and sl
      SL = OrderStopLoss();   
   
      if (SL == 0 || ObjectFind(HlineName) == -1)
      {
         if (SL == 0) SetStop();
      
         if (ObjectFind(HlineName) == -1) DrawLine(HlineName, SL, Color.StopLoss);
         if (OrderStopLoss() != SL) OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),OrderExpiration(),CLR_NONE);
         
      }//if (SL == 0 || ObjectFind(HlineName, 0) == -1)
   
       
   
      SL = ObjectGet(HlineName, OBJPROP_PRICE1);
   
      if (OrderStopLoss() != SL)
      {
         OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),OrderExpiration(),CLR_NONE);
      }//if (OrderTakeProfit() != TP)
   
   }//for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   
//----
   return(0);
  }
//+------------------------------------------------------------------+